<!DOCTYPE html>
<html>
<style>
    html,
    body {
        margin: 0;
        position: absolute;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        overflow: hidden;
    }

    main {
        display: flex;
        flex-direction: column;
        height: 100%;
        width: 100%;
    }

    .controls {
        padding: 8px;
        margin-bottom: 8px;
        height: 80px;
        display: flex;
        flex-direction: row;
    }

    .control-item {
        display: inline-block;
        margin-right: 16px;
    }

    .control-item label,
    .control-item input,
    .control-item select,
    .control-item .display {
        display: block;
    }

    .control-item label {
        display: block;
        font-size: 12px;
        font-weight: bold;
    }

    .control-item input,
    .control-item select {
        width: 100px;
    }

    .control-item button {
        margin-top: 15px;
        width: 100px;
    }

    .display {
        padding: 4px;
        display: flex;
        flex-direction: row;
        width: 300px;
        height: 100%;
        margin-left: auto;
        border: solid 1px black;
    }

    .display .timers {
        border: solid 1px black;
        width: 88px;
        box-sizing: border-box;
        height: 100%;
    }

    .display .timers label {
        font-size: 11px;
        font-weight: bold;
        margin-bottom: 4px;
    }

    .display .timers p {
        font-size: 11px;
        margin-top: 4px;
        margin-bottom: 4px;
    }

    .container {
        display: flex;
        flex-grow: 1;
    }
</style>

<head>
    <script type="text/javascript" src="http://127.0.0.1:8089/web-apps/apps/api/documents/api.js"></script>
</head>

<body>
    <main>
        <div class="controls">
            <div class="control-item">
                <label for="url">Url</label>
                <input id="url" type="text"
                    value="https://file-examples-com.github.io/uploads/2017/02/file-sample_100kB.docx" />
            </div>
            <div class="control-item">
                <label for="key">Key</label>
                <input id="key" type="text" value="Khirz6zTPdfdq" />
            </div>

            <div class="control-item">
                <label for="fileType">File type</label>
                <select name="fileType" id="fileType">
                    <option selected="selected" value="docx">docx</option>
                    <option value="pdf">pdf</option>
                </select>
            </div>

            <div class="control-item">
                <label for="mode">Mode</label>
                <select name="mode" id="mode">
                    <option selected="selected" value="view">view</option>
                    <option value="edit">edit</option>
                </select>
            </div>

            <div class="control-item">
                <label for="lang">Language</label>
                <select name="lang" id="lang">
                    <option selected="selected" value="edit">pt-br</option>
                </select>
            </div>

            <div class="control-item">
                <button onclick="load()">Load</button>
                <button onclick="destroy()">Destroy</button>
            </div>

            <div class="display">
                <div class="timers">
                    <label>Timers</label>
                    <p id="appReadyTimer"></p>
                    <p id="documentReadyTimer"></p>
                </div>
            </div>
        </div>
        <div class="container">
            <div id="onlyoffice"></div>
        </div>
    </main>

    <script>
        var editorInstace = null;
        var initTimer = null;


        function load() {
            cleanDisplay();

            initTimer = performance.now();

            const document = getDocumentConfig();
            const editorConfig = getEditorConfig("http://6006dcbc3698a80017de21a1.mockapi.io/api/editor/callback");
            const events = getEventsConfig();

            validate(document.key, document.url);
            loadEditor(document, editorConfig, events);
        }

        function destroy() {
            cleanDisplay();

            if (editorInstace) {
                editorInstace.destroyEditor();
            } else {
                alert('Editor is not loaded');
            }
        }

        function validate(key, url) {
            if (!url) {
                const message = 'Url should not be empty';
                alert(message);
                throw new Error(message);
            }

            if (!key) {
                const message = 'Key should not be empty';
                alert(message);
                throw new Error(message);
            }
        }

        function loadEditor(document, editorConfig, events) {
            if (editorInstace) {
                editorInstace.destroyEditor();
            }

            editorInstace = new DocsAPI.DocEditor("onlyoffice", { document, editorConfig, events });
        }

        function getDocumentConfig() {
            const key = document.getElementById("key").value;
            const url = document.getElementById("url").value;
            const fileType = document.getElementById("fileType").value;
            const permissions = { edit: true, download: false, print: false, rename: false, review: false };
            return { key, url, fileType, permissions };
        }

        function getEditorConfig(callbackUrl = '') {
            const mode = document.getElementById("mode").value;
            const lang = document.getElementById("lang").value;

            const user = {
                id: '',
                name: '',
            };

            const customization = {
                about: false,
                chat: false,
                comments: true,
                compactToolbar: true,
                leftMenu: true,
                rightMenu: true,
                hideRightMenu: false, // hide or show right panel on first loading
                toolbar: true,
                statusBar: true,
                autosave: false,
                forcesave: true,
                help: false,
                compactHeader: false,
                toolbarNoTabs: false,
                toolbarHideFileName: false,
                reviewDisplay: 'markup',
            };

            return { mode, lang, callbackUrl, user, customization };
        }

        function getEventsConfig() {
            const onAppReady = () => {
                const time = (performance.now() - initTimer) / 1000;
                const result = `App: ${time.toFixed(2)} s`;
                document.getElementById("appReadyTimer").innerHTML = result;
                console.log(result);
            }

            const onDocumentReady = () => {
                const time = (performance.now() - initTimer) / 1000;
                const result = `Document: ${time.toFixed(2)} s`;
                document.getElementById("documentReadyTimer").innerHTML = result;
                console.log(result);
            }

            const events = {
                onAppReady,
                onDocumentReady,
                onCollaborativeChanges: () => { },
                onDocumentStateChange: () => { },
                onDownloadAs: () => { },
                onError: () => { },
                onInfo: () => { },
                onMetaChange: () => { },
                onOutdatedVersion: () => { },
                onRequestClose: () => { },
                onRequestCompareFile: () => { },
                onRequestEditRights: () => { },
                onRequestHistory: () => { },
                onRequestHistoryClose: () => { },
                onRequestHistoryData: () => { },
                onRequestInsertImage: () => { },
                onRequestMailMergeRecipients: () => { },
                onRequestRestore: () => { },
                onRequestSaveAs: () => { },
                onRequestSendNotify: () => { },
                onRequestSharingSettings: () => { },
                onRequestUsers: () => { },
                onWarning: () => { },
            };
            return events;
        }

        function cleanDisplay() {
            document.getElementById("appReadyTimer").innerHTML = '';
            document.getElementById("documentReadyTimer").innerHTML = '';
        }
    </script>
</body>

</html>
